kallsyms: add support for relative offsets in kallsyms address table
[linux-2.6-block.git] / scripts / kconfig / Makefile
CommitLineData
1da177e4
LT
1# ===========================================================================
2# Kernel configuration targets
3# These targets are used from top-level makefile
4
1cba0c30 5PHONY += xconfig gconfig menuconfig config silentoldconfig update-po-config \
281c9dad 6 localmodconfig localyesconfig
1da177e4 7
61bee204
AV
8ifdef KBUILD_KCONFIG
9Kconfig := $(KBUILD_KCONFIG)
10else
838a2e55 11Kconfig := Kconfig
61bee204 12endif
e703f75d 13
0a1f00a1
MM
14ifeq ($(quiet),silent_)
15silent := -s
16endif
17
c2838e6e
YM
18# We need this, in case the user has it in its environment
19unexport CONFIG_
20
1da177e4 21xconfig: $(obj)/qconf
0a1f00a1 22 $< $(silent) $(Kconfig)
1da177e4
LT
23
24gconfig: $(obj)/gconf
0a1f00a1 25 $< $(silent) $(Kconfig)
1da177e4
LT
26
27menuconfig: $(obj)/mconf
0a1f00a1 28 $< $(silent) $(Kconfig)
1da177e4
LT
29
30config: $(obj)/conf
0a1f00a1 31 $< $(silent) --oldaskconfig $(Kconfig)
1da177e4 32
692d97c3 33nconfig: $(obj)/nconf
0a1f00a1 34 $< $(silent) $(Kconfig)
692d97c3 35
1da177e4 36silentoldconfig: $(obj)/conf
9815594a 37 $(Q)mkdir -p include/config include/generated
0a1f00a1 38 $< $(silent) --$@ $(Kconfig)
1da177e4 39
50bce3e8 40localyesconfig localmodconfig: $(obj)/streamline_config.pl $(obj)/conf
9815594a 41 $(Q)mkdir -p include/config include/generated
22d550ae 42 $(Q)perl $< --$@ $(srctree) $(Kconfig) > .tmp.config
7a996d3a 43 $(Q)if [ -f .config ]; then \
4062f1a4
SR
44 cmp -s .tmp.config .config || \
45 (mv -f .config .config.old.1; \
46 mv -f .tmp.config .config; \
0a1f00a1 47 $(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
4062f1a4
SR
48 mv -f .config.old.1 .config.old) \
49 else \
50 mv -f .tmp.config .config; \
0a1f00a1 51 $(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
a7c02602 52 fi
03fa25da
SR
53 $(Q)rm -f .tmp.config
54
1020026f 55# Create new linux.pot file
b70e325c 56# Adjust charset to UTF-8 in .po file to accept UTF-8 in Kconfig files
46d26319 57update-po-config: $(obj)/kxgettext $(obj)/gconf.glade.h
0a1f00a1 58 $(Q)$(kecho) " GEN config.pot"
a24a1b8e
PF
59 $(Q)xgettext --default-domain=linux \
60 --add-comments --keyword=_ --keyword=N_ \
61 --from-code=UTF-8 \
62 --files-from=$(srctree)/scripts/kconfig/POTFILES.in \
63 --directory=$(srctree) --directory=$(objtree) \
b70e325c
SR
64 --output $(obj)/config.pot
65 $(Q)sed -i s/CHARSET/UTF-8/ $(obj)/config.pot
fa0ad657
PB
66 $(Q)(for i in `ls $(srctree)/arch/*/Kconfig \
67 $(srctree)/arch/*/um/Kconfig`; \
1020026f 68 do \
0a1f00a1 69 $(kecho) " GEN $$i"; \
4217516e 70 $(obj)/kxgettext $$i \
1020026f
EG
71 >> $(obj)/config.pot; \
72 done )
0a1f00a1 73 $(Q)$(kecho) " GEN linux.pot"
1020026f 74 $(Q)msguniq --sort-by-file --to-code=UTF-8 $(obj)/config.pot \
b70e325c 75 --output $(obj)/linux.pot
b70e325c 76 $(Q)rm -f $(obj)/config.pot
3b9fa093 77
1cba0c30
MM
78# These targets map 1:1 to the commandline options of 'conf'
79simple-targets := oldconfig allnoconfig allyesconfig allmodconfig \
80 alldefconfig randconfig listnewconfig olddefconfig
81PHONY += $(simple-targets)
1da177e4 82
1cba0c30 83$(simple-targets): $(obj)/conf
0a1f00a1 84 $< $(silent) --$@ $(Kconfig)
1da177e4 85
1cba0c30 86PHONY += oldnoconfig savedefconfig defconfig
1da177e4 87
fb16d891 88# oldnoconfig is an alias of olddefconfig, because people already are dependent
39c3f1ba 89# on its behavior (sets new symbols to their default value but not 'n') with the
fb16d891 90# counter-intuitive name.
1cba0c30 91oldnoconfig: olddefconfig
fb16d891 92
7cf3d73b 93savedefconfig: $(obj)/conf
0a1f00a1 94 $< $(silent) --$@=defconfig $(Kconfig)
7cf3d73b 95
1da177e4
LT
96defconfig: $(obj)/conf
97ifeq ($(KBUILD_DEFCONFIG),)
0a1f00a1 98 $< $(silent) --defconfig $(Kconfig)
bd960f09 99else ifneq ($(wildcard $(srctree)/arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG)),)
0a1f00a1
MM
100 @$(kecho) "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'"
101 $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig)
d2036f30
ME
102else
103 @$(kecho) "*** Default configuration is based on target '$(KBUILD_DEFCONFIG)'"
104 $(Q)$(MAKE) -f $(srctree)/Makefile $(KBUILD_DEFCONFIG)
1da177e4
LT
105endif
106
107%_defconfig: $(obj)/conf
0a1f00a1 108 $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$@ $(Kconfig)
1da177e4 109
63a91033 110configfiles=$(wildcard $(srctree)/kernel/configs/$@ $(srctree)/arch/$(SRCARCH)/configs/$@)
3aaefce1 111
63a91033
MY
112%.config: $(obj)/conf
113 $(if $(call configfiles),, $(error No configuration exists for this target on this architecture))
114 $(Q)$(CONFIG_SHELL) $(srctree)/scripts/kconfig/merge_config.sh -m .config $(configfiles)
115 +$(Q)yes "" | $(MAKE) -f $(srctree)/Makefile oldconfig
3aaefce1
JT
116
117PHONY += kvmconfig
63a91033
MY
118kvmconfig: kvm_guest.config
119 @:
3aaefce1 120
6c668505
LR
121PHONY += xenconfig
122xenconfig: xen.config
123 @:
124
0da1d4a0 125PHONY += tinyconfig
63a91033
MY
126tinyconfig:
127 $(Q)$(MAKE) -f $(srctree)/Makefile allnoconfig tiny.config
0da1d4a0 128
1da177e4
LT
129# Help text used by make help
130help:
131 @echo ' config - Update current config utilising a line-oriented program'
fa75a727
GU
132 @echo ' nconfig - Update current config utilising a ncurses menu based'
133 @echo ' program'
1da177e4 134 @echo ' menuconfig - Update current config utilising a menu based program'
092373c2 135 @echo ' xconfig - Update current config utilising a Qt based front-end'
39c3f1ba 136 @echo ' gconfig - Update current config utilising a GTK+ based front-end'
1da177e4 137 @echo ' oldconfig - Update current config utilising a provided .config as base'
03fa25da 138 @echo ' localmodconfig - Update current config disabling modules not loaded'
281c9dad 139 @echo ' localyesconfig - Update current config converting local mods to core'
590a5857 140 @echo ' silentoldconfig - Same as oldconfig, but quietly, additionally update deps'
0748cb3e 141 @echo ' defconfig - New config with default from ARCH supplied defconfig'
7cf3d73b 142 @echo ' savedefconfig - Save current config as ./defconfig (minimal config)'
e11f0496 143 @echo ' allnoconfig - New config where all options are answered with no'
0748cb3e
SR
144 @echo ' allyesconfig - New config where all options are accepted with yes'
145 @echo ' allmodconfig - New config selecting modules when possible'
146 @echo ' alldefconfig - New config with all symbols set to default'
147 @echo ' randconfig - New config with random answer to all options'
861b4ea4 148 @echo ' listnewconfig - List new options'
fa75a727
GU
149 @echo ' olddefconfig - Same as silentoldconfig but sets new symbols to their'
150 @echo ' default value'
9bcd776d 151 @echo ' kvmconfig - Enable additional options for kvm guest kernel support'
6c668505 152 @echo ' xenconfig - Enable additional options for xen dom0 and guest kernel support'
0da1d4a0 153 @echo ' tinyconfig - Configure the tiniest possible kernel'
1da177e4 154
2982de69
SR
155# lxdialog stuff
156check-lxdialog := $(srctree)/$(src)/lxdialog/check-lxdialog.sh
157
e9e40e14 158# Use recursively expanded variables so we do not call gcc unless
2982de69 159# we really need to do so. (Do not call gcc as part of make mrproper)
9ba95682
AL
160HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(check-lxdialog) -ccflags) \
161 -DLOCALE
2982de69 162
1da177e4
LT
163# ===========================================================================
164# Shared Makefile for the various kconfig executables:
165# conf: Used for defconfig, oldconfig and related targets
692d97c3 166# nconf: Used for the nconfig target.
167# Utilizes ncurses
6f26e5e4 168# mconf: Used for the menuconfig target
1da177e4
LT
169# Utilizes the lxdialog package
170# qconf: Used for the xconfig target
092373c2 171# Based on Qt which needs to be installed to compile it
1da177e4 172# gconf: Used for the gconfig target
39c3f1ba 173# Based on GTK+ which needs to be installed to compile it
1da177e4
LT
174# object files used by all kconfig flavours
175
2982de69
SR
176lxdialog := lxdialog/checklist.o lxdialog/util.o lxdialog/inputbox.o
177lxdialog += lxdialog/textbox.o lxdialog/yesno.o lxdialog/menubox.o
178
1da177e4 179conf-objs := conf.o zconf.tab.o
692d97c3 180mconf-objs := mconf.o zconf.tab.o $(lxdialog)
181nconf-objs := nconf.o zconf.tab.o nconf.gui.o
3b9fa093 182kxgettext-objs := kxgettext.o zconf.tab.o
f1943049 183qconf-cxxobjs := qconf.o
5a6f8d2b
AL
184qconf-objs := zconf.tab.o
185gconf-objs := gconf.o zconf.tab.o
1da177e4 186
022af62d 187hostprogs-y := conf nconf mconf kxgettext qconf gconf
1da177e4 188
5a6f8d2b 189clean-files := qconf.moc .tmp_qtcheck .tmp_gtkcheck
2f76b358 190clean-files += zconf.tab.c zconf.lex.c zconf.hash.c gconf.glade.h
1020026f 191clean-files += config.pot linux.pot
1da177e4 192
6e588f6d
SR
193# Check that we have the required ncurses stuff installed for lxdialog (menuconfig)
194PHONY += $(obj)/dochecklxdialog
195$(addprefix $(obj)/,$(lxdialog)): $(obj)/dochecklxdialog
196$(obj)/dochecklxdialog:
7080e47b 197 $(Q)$(CONFIG_SHELL) $(check-lxdialog) -check $(HOSTCC) $(HOST_EXTRACFLAGS) $(HOSTLOADLIBES_mconf)
6e588f6d
SR
198
199always := dochecklxdialog
200
aa1e5ef5
SR
201# Add environment specific flags
202HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCC) $(HOSTCFLAGS))
70a6a0cb 203
1da177e4 204# generated files seem to need this to find local include files
2f76b358 205HOSTCFLAGS_zconf.lex.o := -I$(src)
1da177e4
LT
206HOSTCFLAGS_zconf.tab.o := -I$(src)
207
378dbb2c
AL
208LEX_PREFIX_zconf := zconf
209YACC_PREFIX_zconf := zconf
210
5a6f8d2b
AL
211HOSTLOADLIBES_qconf = $(KC_QT_LIBS)
212HOSTCXXFLAGS_qconf.o = $(KC_QT_CFLAGS)
1da177e4 213
5a6f8d2b 214HOSTLOADLIBES_gconf = `pkg-config --libs gtk+-2.0 gmodule-2.0 libglade-2.0`
37193147 215HOSTCFLAGS_gconf.o = `pkg-config --cflags gtk+-2.0 gmodule-2.0 libglade-2.0` \
1ea3ad4e 216 -Wno-missing-prototypes
1da177e4 217
7080e47b
AL
218HOSTLOADLIBES_mconf = $(shell $(CONFIG_SHELL) $(check-lxdialog) -ldflags $(HOSTCC))
219
544e7e54 220HOSTLOADLIBES_nconf = $(shell \
7285996a
BN
221 pkg-config --libs menuw panelw ncursesw 2>/dev/null \
222 || pkg-config --libs menu panel ncurses 2>/dev/null \
544e7e54 223 || echo "-lmenu -lpanel -lncurses" )
1da177e4
LT
224$(obj)/qconf.o: $(obj)/.tmp_qtcheck
225
022af62d 226ifeq ($(MAKECMDGOALS),xconfig)
b3a5225f 227$(obj)/.tmp_qtcheck: $(src)/Makefile
1da177e4
LT
228-include $(obj)/.tmp_qtcheck
229
092373c2 230# Qt needs some extra effort...
1da177e4 231$(obj)/.tmp_qtcheck:
d1b0dc90 232 @set -e; $(kecho) " CHECK qt"; \
588446a8
TM
233 if pkg-config --exists Qt5Core; then \
234 cflags="-std=c++11 -fPIC `pkg-config --cflags Qt5Core Qt5Gui Qt5Widgets`"; \
235 libs=`pkg-config --libs Qt5Core Qt5Gui Qt5Widgets`; \
236 moc=`pkg-config --variable=host_bins Qt5Core`/moc; \
237 elif pkg-config --exists QtCore; then \
238 cflags=`pkg-config --cflags QtCore QtGui`; \
239 libs=`pkg-config --libs QtCore QtGui`; \
240 moc=`pkg-config --variable=moc_location QtCore`; \
ab919c06 241 else \
d1b0dc90 242 echo >&2 "*"; \
588446a8
TM
243 echo >&2 "* Could not find Qt via pkg-config."; \
244 echo >&2 "* Please install either Qt 4.8 or 5.x. and make sure it's in PKG_CONFIG_PATH"; \
d1b0dc90
TM
245 echo >&2 "*"; \
246 exit 1; \
b3a5225f
RZ
247 fi; \
248 echo "KC_QT_CFLAGS=$$cflags" > $@; \
249 echo "KC_QT_LIBS=$$libs" >> $@; \
250 echo "KC_QT_MOC=$$moc" >> $@
1da177e4
LT
251endif
252
253$(obj)/gconf.o: $(obj)/.tmp_gtkcheck
254
022af62d 255ifeq ($(MAKECMDGOALS),gconfig)
1da177e4
LT
256-include $(obj)/.tmp_gtkcheck
257
39c3f1ba 258# GTK+ needs some extra effort, too...
1da177e4 259$(obj)/.tmp_gtkcheck:
37193147
AB
260 @if `pkg-config --exists gtk+-2.0 gmodule-2.0 libglade-2.0`; then \
261 if `pkg-config --atleast-version=2.0.0 gtk+-2.0`; then \
1da177e4
LT
262 touch $@; \
263 else \
5b580fa6
MM
264 echo >&2 "*"; \
265 echo >&2 "* GTK+ is present but version >= 2.0.0 is required."; \
266 echo >&2 "*"; \
1da177e4
LT
267 false; \
268 fi \
269 else \
5b580fa6
MM
270 echo >&2 "*"; \
271 echo >&2 "* Unable to find the GTK+ installation. Please make sure that"; \
272 echo >&2 "* the GTK+ 2.0 development package is correctly installed..."; \
273 echo >&2 "* You need gtk+-2.0, glib-2.0 and libglade-2.0."; \
274 echo >&2 "*"; \
1da177e4
LT
275 false; \
276 fi
277endif
278
2f76b358 279$(obj)/zconf.tab.o: $(obj)/zconf.lex.c $(obj)/zconf.hash.c
1da177e4 280
5a6f8d2b 281$(obj)/qconf.o: $(obj)/qconf.moc
1da177e4 282
ebca026a
YS
283quiet_cmd_moc = MOC $@
284 cmd_moc = $(KC_QT_MOC) -i $< -o $@
285
286$(obj)/%.moc: $(src)/%.h $(obj)/.tmp_qtcheck
287 $(call cmd,moc)
1da177e4 288
39c3f1ba 289# Extract gconf menu items for i18n support
46d26319 290$(obj)/gconf.glade.h: $(obj)/gconf.glade
2d80eb0f 291 $(Q)intltool-extract --type=gettext/glade --srcdir=$(srctree) \
a24a1b8e 292 $(obj)/gconf.glade